_gss_ntlm_init_sec_context() mem leaks
[heimdal.git] / tests / kdc / check-des.in
blob144613df4f991bd5214986a8b1755243733e35c9
1 #!/bin/sh
3 # Copyright (c) 2006 - 2008 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
32 # SUCH DAMAGE.
34 top_builddir="@top_builddir@"
35 env_setup="@env_setup@"
36 objdir="@objdir@"
38 testfailed="echo test failed; cat messages.log; exit 1"
40 . ${env_setup}
42 # If there is no useful db support compiled in, disable test
43 ${have_db} || exit 77
45 R=TEST.H5L.SE
46 R2=TEST2.H5L.SE
48 port=@port@
50 kadmin="${kadmin} -l -r $R"
51 kdc="${kdc} --addresses=localhost -P $port"
53 afsserver=afs/test.h5l.se
54 hostserver=host/server.test.h5l.se
55 cache="FILE:${objdir}/cache.krb5"
57 kinit="${kinit} -c $cache ${afs_no_afslog}"
58 klist="${klist} -c $cache"
59 kgetcred="${kgetcred} -c $cache"
60 kdestroy="${kdestroy} -c $cache ${afs_no_unlog}"
62 KRB5_CONFIG="${objdir}/krb5.conf"
63 export KRB5_CONFIG
65 rm -f ${keytabfile}
66 rm -f current-db*
67 rm -f out-*
68 rm -f mkey.file*
70 > messages.log
72 echo Creating database
73 ${kadmin} \
74 init \
75 --realm-max-ticket-life=1day \
76 --realm-max-renewable-life=1month \
77 ${R} || exit 1
79 ${kadmin} \
80 init \
81 --realm-max-ticket-life=1day \
82 --realm-max-renewable-life=1month \
83 ${R2} || exit 1
85 ${kadmin} cpw -r krbtgt/${R}@${R} || exit 1
87 ${kadmin} add -p foo --use-defaults foo@${R} || exit 1
88 ${kadmin} add -p kaka --use-defaults ${afsserver}@${R} || exit 1
89 ${kadmin} add -p kaka --use-defaults ${hostserver}@${R} || exit 1
90 ${kadmin} add_enctype -r ${afsserver}@${R} des-cbc-crc || exit 1
91 ${kadmin} add_enctype -r ${hostserver}@${R} des-cbc-crc || exit 1
93 echo "Doing database check"
94 ${kadmin} check ${R} || exit 1
96 echo foo > ${objdir}/foopassword
98 echo Starting kdc; > messages.log
99 ${kdc} --detach --testing || { echo "kdc failed to start"; cat messages.log; exit 1; }
100 kdcpid=`getpid kdc`
102 trap "kill -9 ${kdcpid}; echo signal killing kdc; exit 1;" EXIT
104 ec=0
106 echo "Getting client initial tickets"; > messages.log
107 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
108 { ec=1 ; eval "${testfailed}"; }
109 echo "Getting non des tickets (afs)"; > messages.log
110 ${kgetcred} ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
111 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
112 echo "Getting non des tickets (host/)"; > messages.log
113 ${kgetcred} ${hostserver}@${R} || { ec=1 ; eval "${testfailed}"; }
114 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
115 ${kdestroy}
118 echo "Getting client initial tickets"; > messages.log
119 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
120 { ec=1 ; eval "${testfailed}"; }
121 echo "Getting des tickets (fail test)"; > messages.log
122 ${kgetcred} -e des-cbc-crc ${hostserver}@${R} 2>/dev/null && \
123 { ec=1 ; eval "${testfailed}"; }
124 echo "Getting non des tickets"; > messages.log
125 ${kgetcred} ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
126 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
129 KRB5_CONFIG="${objdir}/krb5-weak.conf"
131 echo "Getting client initial tickets"; > messages.log
132 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
133 { ec=1 ; eval "${testfailed}"; }
135 echo "Getting non des tickets (host/), failure test"; > messages.log
136 ${kgetcred} -e des-cbc-crc ${hostserver}@${R} 2>/dev/null && \
137 { ec=1 ; eval "${testfailed}"; }
138 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
140 echo "Getting des tickets (afs)"; > messages.log
141 ${kgetcred} -e des-cbc-crc ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
142 ${klist} -v | grep des-cbc-crc > /dev/null || { ec=1 ; eval "${testfailed}"; }
144 ${kdestroy}
148 ${kdestroy}
150 echo "killing kdc (${kdcpid})"
151 sh ${leaks_kill} kdc $kdcpid || exit 1
153 trap "" EXIT
155 exit $ec